<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.carenterrecord_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/carenterrecord";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: false,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          menuWidth:350,
          column: [
            // {
            //   label: "索引ID",
            //   prop: "indexId",
            //   rules: [{
            //     required: true,
            //     message: "请输入索引ID",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "	车场唯一编号",
              prop: "parkKey",
              hide:true,
              display:false,
              rules: [{
                required: false,
                message: "请输入	车场唯一编号",
                trigger: "blur"
              }]
            },
            {
              label: "车牌号码",
              prop: "carNo",
              rules: [{
                required: false,
                message: "请输入车牌号码",
                trigger: "blur"
              }]
            },
            {
              label: "所属社区",
              prop: "agencyId",
              // slot: true,
              search: true,
              cascaderItem: ['residentialId'],
              type: "select",
              // remote: true,
              searchFilterable:true,
              filterable: true,
              dicUrl: "/api/cyzh-community/agency/list?size=1000&name={{key}}",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择所属社区",
                trigger: "blur"
              }]
            },
            {
              label: "所属小区",
              prop: "residentialId",
              // slot: true,
              type: "select",
              search: true,
              cascaderItem: ['buildingId'],
              dicUrl: "/api/cyzh-community/residential/list?agencyId={{key}}",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              // dicFlag: false,
              filterable: true,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择所属小区",
                trigger: "blur"
              }]
            },
            {
              label: "所属企业",
              prop: "enterpriseId",
              hide:true,
              type:'select',
              dicData:'/api/cyzh-enterprise/enterprise/list',
              rules: [{
                required: false,
                message: "请输入企业",
                trigger: "blur"
              }]
            },
            {
              label: "车辆类型",
              prop: "carTypeNo",
              type:'select',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=car-type-no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              rules: [{
                required: true,
                message: "请输入车辆类型",
                trigger: "blur"
              }]
            },
            {
              label: "车辆状态",
              prop: "lockCar",
              type:"select",
              hide:true,
              display: false,
              dicData:[
                {
                  label:'未锁',
                  value:0
                },{
                  label: '锁定',
                  value:1
                }
              ],
              rules: [{
                required: false,
                message: "请输入车辆状态（0-未锁 1-锁定）",
                trigger: "blur"
              }]
            },
            {
              label: "入场时间	",
              prop: "enterTime",
              type:'datetime',
              valueFormat:'yyyy-MM-dd HH:mm:ss',
              rules: [{
                required: true,
                message: "请输入入场时间	",
                trigger: "blur"
              }]
            },
            {
              label: "入口车道名称	",
              prop: "enterGateName",
              labelWidth:120,
              rules: [{
                required: false,
                message: "请输入入口车道名称	",
                trigger: "blur"
              }]
            },
            {
              label: "入口操作员	",
              prop: "enterOperatorName",
              hide:true,
              rules: [{
                required: false,
                message: "请输入入口操作员	",
                trigger: "blur"
              }]
            },
            {
              label: "订单号",
              prop: "orderNo",
              hide:true,
              rules: [{
                required: false,
                message: "请输入订单号",
                trigger: "blur"
              }]
            },
            {
              label: "预约车位订单号",
              labelWidth: 120,
              prop: "reserveOrderNo",
              rules: [{
                required: false,
                message: "请输入预约车位订单号",
                trigger: "blur"
              }]
            },
            {
              label: "入场图片	",
              prop: "enterImgPath",
              type:'upload',
              listType: 'picture-img',
              propsHttp: {
                res: "data",
                url: "link"
              },
              action: "/api/blade-resource/oss/endpoint/put-file",
              tip: '只能生产jpg/png图片，且不超过500kb',
              rules: [{
                required: false,
                message: "请输入入场图片	",
                trigger: "blur"
              }]
            },
            // {
            //   label: "路径",
            //   prop: "orgPosition",
            //   rules: [{
            //     required: true,
            //     message: "请输入路径",
            //     trigger: "blur"
            //   }]
            // },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.carenterrecord_add, false),
          viewBtn: this.vaildData(this.permission.carenterrecord_view, false),
          delBtn: this.vaildData(this.permission.carenterrecord_delete, false),
          editBtn: this.vaildData(this.permission.carenterrecord_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
